#include <iostream>
#include <string>

using namespace std;

/*
    This code illustrates one of the difficulties of using references
    in C++. You would expect this program to print "hello world".
    But it does not. Instead, it either crashes, or outputs garbage.
    And the compiler does not even warn.
*/

class hum
{
    const string &s;
public:
    hum(const string &ss) : s(ss)
    {
    }
    void dump(void)
    {
        cout << s << endl;
    }
};

int main(void)
{
    /* Create a class using a reference to temporary */
    hum p = hum(string("hello") + string(" world"));
    
    p.dump();
    
    return 0;
}
